about summary refs log tree commit diff
path: root/scripts
diff options
context:
space:
mode:
Diffstat (limited to 'scripts')
-rw-r--r--scripts/.gitignore1
-rw-r--r--scripts/build-chroot.sh74
-rw-r--r--scripts/chat.tmux.conf59
-rw-r--r--scripts/chroot-prompt.sh3
-rw-r--r--scripts/sandman.136
-rw-r--r--scripts/sandman.m87
6 files changed, 122 insertions, 138 deletions
diff --git a/scripts/.gitignore b/scripts/.gitignore
deleted file mode 100644
index f6dc107..0000000
--- a/scripts/.gitignore
+++ /dev/null
@@ -1 +0,0 @@
-sandman
diff --git a/scripts/build-chroot.sh b/scripts/build-chroot.sh
new file mode 100644
index 0000000..a0fcf32
--- /dev/null
+++ b/scripts/build-chroot.sh
@@ -0,0 +1,74 @@
+#!/bin/sh
+set -eux
+
+CHROOT_USER=$1
+CHROOT_GROUP=$2
+
+if [ "$(uname)" = 'OpenBSD' ]; then
+	install -d -o root -g wheel \
+		root \
+		root/bin \
+		root/etc/ssl \
+		root/home \
+		root/usr/bin \
+		root/usr/lib \
+		root/usr/libexec \
+		root/usr/share/man
+	install -d -o ${CHROOT_USER} -g ${CHROOT_GROUP} \
+		root/home/${CHROOT_USER} \
+		root/home/${CHROOT_USER}/.local/share
+
+	cp -fp /bin/sh root/bin
+	cp -fp /usr/libexec/ld.so root/usr/libexec
+	export LD_TRACE_LOADED_OBJECTS_FMT1='%p\n'
+	export LD_TRACE_LOADED_OBJECTS_FMT2=''
+	for bin in ./catgirl /usr/bin/mandoc /usr/bin/less; do
+		LD_TRACE_LOADED_OBJECTS=1 $bin | xargs -t -J % cp -fp % root/usr/lib
+	done
+	cp -fp /usr/bin/printf /usr/bin/mandoc /usr/bin/less root/usr/bin
+	make install DESTDIR=root PREFIX=/usr MANDIR=/usr/share/man
+	install scripts/chroot-prompt.sh root/usr/bin/catgirl-prompt
+	install scripts/chroot-man.sh root/usr/bin/man
+
+	cp -fp /etc/hosts /etc/resolv.conf root/etc
+	cp -fp /etc/ssl/cert.pem root/etc/ssl
+	cp -af /usr/share/locale /usr/share/terminfo root/usr/share
+
+	tar -c -f chroot.tar -C root bin etc home usr
+
+elif [ "$(uname)" = 'FreeBSD' ]; then
+	install -d -o root -g wheel \
+		root \
+		root/bin \
+		root/etc \
+		root/home \
+		root/lib \
+		root/libexec \
+		root/usr/bin \
+		root/usr/local/etc/ssl \
+		root/usr/share/man \
+		root/usr/share/misc
+	install -d -o ${CHROOT_USER} -g ${CHROOT_GROUP} \
+		root/home/${CHROOT_USER} \
+		root/home/${CHROOT_USER}/.local/share
+
+	cp -fp /libexec/ld-elf.so.1 root/libexec
+	ldd -f '%p\n' catgirl /usr/bin/mandoc /usr/bin/less \
+		| sort -u | xargs -t -J % cp -fp % root/lib
+	chflags noschg root/libexec/* root/lib/*
+	cp -fp /rescue/sh /usr/bin/mandoc /usr/bin/less root/bin
+	make install DESTDIR=root PREFIX=/usr MANDIR=/usr/share/man
+	install scripts/chroot-prompt.sh root/usr/bin/catgirl-prompt
+	install scripts/chroot-man.sh root/usr/bin/man
+
+	cp -fp /etc/hosts /etc/resolv.conf root/etc
+	cp -fp /usr/local/etc/ssl/cert.pem root/usr/local/etc/ssl
+	cp -af /usr/share/locale root/usr/share
+	cp -fp /usr/share/misc/termcap.db root/usr/share/misc
+
+	tar -c -f chroot.tar -C root bin etc home lib libexec usr
+
+else
+	echo "Don't know how to build chroot on $(uname)" >&2
+	exit 1
+fi
diff --git a/scripts/chat.tmux.conf b/scripts/chat.tmux.conf
index 9191b1a..3489a19 100644
--- a/scripts/chat.tmux.conf
+++ b/scripts/chat.tmux.conf
@@ -1,31 +1,64 @@
 # use `tmux -L chat -f ./chat.tmux.conf attach-session' (without any other
 # options or parameters) to access this session group in its own tmux server,
 # not interfering with existing servers/sessions/configurations
+
 new-session -t chat
 
+# catgirl(1) puts windows at the top
+set-option -g	-- status-position	top
+
 # intuitive navigation
-set-option -g	mode-keys	vi
-set-option -g	mouse	on
+set-option -g	-- mode-keys	vi
+set-option -g	-- mouse	on
 
 # indicate new messages
-set-option -g	monitor-activity	on
-set-option -g	monitor-bell	on
+set-option -g	-- monitor-activity	on
+set-option -g	-- monitor-bell	on
 
 # hardcode names during window creation
-set-option -g	automatic-rename	off
-set-option -g	allow-rename	off
-set-option -g	set-titles	off
-set-option -g	renumber-windows	on
+set-option -g	-- automatic-rename	off
+set-option -g	-- allow-rename	off
+set-option -g	-- set-titles	off
+set-option -g	-- renumber-windows	on
+# for the F1 binding, make hotkeys match window numbers
+set-option -g	-- base-index	1
+
 
 # clients exit on network errors, restart them automatically
 # (use `kill-pane'/`C-b x' to destroy windows)
-set-option -g	remain-on-exit	on
-set-hook -g	pane-died	respawn-pane
+set-option -g	-- remain-on-exit	on
+set-hook -g	-- pane-died	respawn-pane
+
+
+# disarm ^C to avoid accidentially losing logs
+bind-key -n -N 'confirm INTR key'	-- C-c	\
+	confirm-before -p 'Send ^C? (y/N)'	-- 'send-keys	-- C-c'
+
+# one-click version of default `C-b w' (shows preview windows)
+bind-key -n -N 'pick chat network'	-- F1	choose-tree -Z
+
+# catgirl(1) might run in `-R'/`restrict'ed mode, i.e. `/help' is disabled
+bind-key -n -N 'read catgirl help'	-- F2	\
+	new-window -S -n help	-- man -s 1	-- catgirl
+
+# intuitive refresh, just don't spam it ;-)
+bind-key -n -N 'reconnect network'	-- F5	\
+	confirm-before -p 'reconnect network? (y/N)'	-- 'respawn-pane -k'
+
+# immersive mode ;-)
+bind-key -n -N 'toggle fullscreen'	-- F11	set status
+
+
+# this configuration is idempotent, i.e. reloading it only changes settings
+# and never duplicates already existing windows
+bind-key -N 'reload configuration'	-- R	{
+	source-file -F	-- '#{source_files}'
+	display-message	-- 'configuration reloaded'
+}
 
 
 ## do not double-quote commands to avoid running through "sh -c"
 
 # IRC
-new-window -n efnet	-- catgirl efnet
-new-window -n freenode	-- catgirl freenode
-new-window -n hackint	-- catgirl hackint
+new-window -d -S -n hackint	-- catgirl	-- defaults hackint
+new-window -d -S -n efnet	-- catgirl	-- defaults efnet
diff --git a/scripts/chroot-prompt.sh b/scripts/chroot-prompt.sh
index 3b43841..2b34426 100644
--- a/scripts/chroot-prompt.sh
+++ b/scripts/chroot-prompt.sh
@@ -3,4 +3,5 @@ set -eu
 
 printf 'Name: '
 read -r nick rest
-exec catgirl -n "$nick" -s "$nick" "$@"
+printf '%s %s\n' "$nick" "$SSH_CLIENT" >>nicks.log
+exec catgirl -K -n "$nick" -s "${nick##*/}" -u "${SSH_CLIENT%% *}" "$@"
diff --git a/scripts/sandman.1 b/scripts/sandman.1
deleted file mode 100644
index 35765ec..0000000
--- a/scripts/sandman.1
+++ /dev/null
@@ -1,36 +0,0 @@
-.Dd February 12, 2020
-.Dt SANDMAN 1
-.Os
-.
-.Sh NAME
-.Nm sandman
-.Nd sleep wrapper
-.
-.Sh SYNOPSIS
-.Nm
-.Op Fl t Ar secs
-.Ar command ...
-.
-.Sh DESCRIPTION
-The
-.Nm
-utility wraps a
-.Ar command ,
-sending it
-.Dv SIGHUP
-when the system goes to sleep,
-and restarting it
-when the system wakes.
-.
-.Pp
-The arguments are as follows:
-.Bl -tag -width Ds
-.It Fl t Ar secs
-Wait for
-.Ar secs
-before restarting the process.
-The default is 8 seconds.
-.El
-.
-.Sh AUTHORS
-.An June Bug Aq Mt june@causal.agency
diff --git a/scripts/sandman.m b/scripts/sandman.m
deleted file mode 100644
index 99899ab..0000000
--- a/scripts/sandman.m
+++ /dev/null
@@ -1,87 +0,0 @@
-/* Copyright (C) 2019, 2020  C. McEnroe <june@causal.agency>
- *
- * This program is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program.  If not, see <https://www.gnu.org/licenses/>.
- */
-
-#import <Cocoa/Cocoa.h>
-#import <err.h>
-#import <signal.h>
-#import <stdio.h>
-#import <stdlib.h>
-#import <sysexits.h>
-#import <unistd.h>
-
-typedef unsigned uint;
-
-static pid_t pid;
-static void spawn(char *argv[]) {
-	pid = fork();
-	if (pid < 0) err(EX_OSERR, "fork");
-	if (pid) return;
-	execvp(argv[0], argv);
-	err(EX_CONFIG, "%s", argv[0]);
-}
-
-static void handler(int signal) {
-	(void)signal;
-	int status;
-	pid_t pid = wait(&status);
-	if (pid < 0) _exit(EX_OSERR);
-	_exit(status);
-}
-
-int main(int argc, char *argv[]) {
-	uint delay = 8;
-
-	for (int opt; 0 < (opt = getopt(argc, argv, "t:"));) {
-		switch (opt) {
-			break; case 't': delay = strtoul(optarg, NULL, 10);
-			break; default:  return EX_USAGE;
-		}
-	}
-	argc -= optind;
-	argv += optind;
-	if (!argc) errx(EX_USAGE, "command required");
-
-	NSWorkspace *workspace = [NSWorkspace sharedWorkspace];
-	NSNotificationCenter *notifCenter = [workspace notificationCenter];
-
-	[notifCenter addObserverForName:NSWorkspaceWillSleepNotification
-							 object:nil
-							  queue:nil
-						 usingBlock:^(NSNotification *notif) {
-							 (void)notif;
-							 signal(SIGCHLD, SIG_IGN);
-							 int error = kill(pid, SIGHUP);
-							 if (error) err(EX_UNAVAILABLE, "kill");
-							 int status;
-							 wait(&status);
-						 }];
-
-	[notifCenter addObserverForName:NSWorkspaceDidWakeNotification
-							 object:nil
-							  queue:nil
-						 usingBlock:^(NSNotification *notif) {
-							 (void)notif;
-							 warnx("waiting %u seconds...", delay);
-							 sleep(delay);
-							 signal(SIGCHLD, handler);
-							 spawn(argv);
-						 }];
-
-	signal(SIGCHLD, handler);
-	spawn(argv);
-
-	[[NSApplication sharedApplication] run];
-}